#!/bin/bash

# shellscript zur Loggen von Telnet Daten einer Hargasser classic Baujahr 2015
# die daten werden in einer Excel conformen CSV Datei gespeichert

TempLog="/mnt/dietpi_userdata/Hargassner/Temp.log"
CSVLog="/mnt/dietpi_userdata/Hargassner/Hargassner.csv"
DateLog="/mnt/dietpi_userdata/Hargassner/Date.log"

# Das akutelle Datum umd Zeit wird in eine Datei geschrieben
date   +%d.%m.%Y" "%H:%M > "$DateLog"
# 10 Sekunden wird an Telnet gelauscht und in eine Datei geschrieben
timeout 10 nc  192.168.66.215 23 > "$TempLog"
# Für eine Weitergearbeitung in deutschen Excel werden nun Punkte durch Komma ersetzt
sed -i 's/\./,/g' "$TempLog"							
# Um eine Excel csv Datei zu erstellen werden nun Leerzeichen durch Semikolon ersetzt
sed -i 's/ /;/g' "$TempLog"
# Da oben wegen der Aufzeichnungssichheit 10 Sekunden am Telnet gelauscht wurde wird
# nun auf eine Zele gekürzt, bei HSV classic von Baujahr 05.2015 sind das 581 Zeichen
sed -i -r 's/(.{581}).*/\1/;q' "$TempLog"
# Nun wird an die Datumsdatei die Temp Datein mit der Aufzeichungszeile angehängt 
cat "$TempLog" >> "$DateLog"
# Die Datumsdatei mit Datumsangabe und Aufzeichnungszeile wird nun 
# auf die die "alte" Temp Datei kopiert und dabei überschrieben
mv "$DateLog" "$TempLog"
# Nun wird der Zeilenumbruch aus der Datei entfernt und durch ein Simekolon ersetzt
sed -i ':a;N;$!ba;s/\n/;/g' "$TempLog"
# Da das aktuelle Datum immer zu oberst sei soll, wird nun die die schon bestehende
# cvs Datei an die Temp Datein angehängt
cat "$CSVLog" >> "$TempLog"
# Die Temp Datei wieder auf die "alte" csv Datei kopieren
mv "$TempLog" "$CSVLog"
# Damit die Log Datei nicht undendlich Gross wird 
# wird nun die Datei durch kopieren der ersten 2016 Zeilen 
# un schreiben in Temp Datein , Aufzeichnungslänge eingekürzt
# Bei einer Ausführung dieses scriptes per Cron Job alle 5 Minuten
# ergibts sich eine Aufzeichnungslänge von einer Woche 
sed -ne '1,2016p'  "$CSVLog" > "$TempLog"
# Zurückschreiben der Temp Datei in die csv datei
mv "$TempLog" "$CSVLog"
